#include <fstream>
#include "../IncludeOnce.h"
#include "../code-files/CfCode.h"
#include "../code-files/CfLayout.h"
#include "../code.h"
#include "CtDefined.h"


void CtDefined::declare( CfFile &out ) const
{
  out << "#ifndef _typedef_" << *this << '\n'
      << "#define _typedef_" << *this << '\n'
      << "typedef struct " << *this << ' ' << *this << ";\n"
      << "#endif\n";
}


void CtDefined::define( CfFile &out ) const
{
  out.include( CfLayout::deriveName( *this ) );
}


void CtDefined::elaborate() const
{
  CfLayout out( *this );
  elaborateTo( out );
}


// Local Variables:
// c-file-style: "gnu"
// End:
