#include "AST.h"
#include "domain-decls.h"
#include "code.h"


bool PointArrayAccessNode::isLocalLvalue()
{
  return true;
}


bool PointArrayAccessNode::isSimpleLvalue()
{
  return true;
}


const string PointArrayAccessNode::emitExpression2( CodeContext &context )
{
  const string arrayExpr = array()->simpleVar( context );
  const string indexExpr = index()->emitExpression( context );

  return MANGLE_TI_DOMAINS_POINT_DISPATCH(+, "getPrevious", int2string(array()->type()->tiArity()), MANGLE_INT_ARG(+)) + "(" + arrayExpr + ", " + indexExpr + ')';
}
