#ifndef _INCLUDE_CLASS_HEADER_
#define _INCLUDE_CLASS_HEADER_

/* must appear before <sys/types.h> on Solaris */
#include "file-64.h"

#include <sys/types.h>
#include "category.h"
#include "config.h"
#include "gp-type.h"
#include "linkage.h"
struct class_header;
typedef struct class_header class_header;
#include "T5Class4lang4java.h"
#include "layout!LT6String4lang4java.h"


EXTERN_C_BEGIN

struct instance_header;
struct interface_header;

struct class_header
{
    T5Class4lang4java class_object; /* MUST come first */
    LT6String4lang4java class_name;

    enum TypeCategory category;
    const struct interface_header * const *implements;
    const struct class_header *super;
    size_t size;
    void (*nullifyLocalFields)( struct instance_header * );
};

EXTERN_C_END

#endif
