#include "gc.h"
#include "mem-local.h"
#include "java_string.h"
#include "native-utils.h"

void tossMonitorStateException_str(char * const ascii)
{
    const LP_JString message = java_string_build_8( ascii );
    m33throwIllegalMonitorStateExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    abort();			/* should never be reached */
}


void tossIllegalArgumentException_str(char * const ascii)
{

    const LP_JString message = java_string_build_8( ascii );
    m29throwIllegalArgumentExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    
    abort();                    /* should never be reached */
}

void tossNullPointerException_str(char * const ascii) 
{
    const LP_JString message = java_string_build_8( ascii );
    m25throwNullPointerExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    
    abort();                    /* should never be reached */
}

