

package ti.lang;

final public class Scan  {
  static private int myproc = Ti.thisProc();
  static private int single procs = Ti.numProcs();




















  public static sglobal int    add (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  add (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    add (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  add (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal double    add (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static double  add (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;

      a[i] = val;

    }
    return val;
  }




























  public static sglobal int    mult (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  mult (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    mult (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  mult (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal double    mult (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static double  mult (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;

      a[i] = val;

    }
    return val;
  }




























  public static sglobal int    min (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  min (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    min (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  min (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal double    min (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static double  min (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }




























  public static sglobal int    max (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  max (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    max (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  max (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal double    max (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static double  max (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;

      a[i] = val;

    }
    return val;
  }






























  public static sglobal int    or (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  or (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    or (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  or (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;

      a[i] = val;

    }
    return val;
  }
























  public static sglobal boolean    or (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static boolean  or (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;

      a[i] = val;

    }
    return val;
  }






























  public static sglobal int    xor (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  xor (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    xor (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  xor (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;

      a[i] = val;

    }
    return val;
  }
























  public static sglobal boolean    xor (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static boolean  xor (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;

      a[i] = val;

    }
    return val;
  }






























  public static sglobal int    and (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  and (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;

      a[i] = val;

    }
    return val;
  }





















  public static sglobal long    and (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  and (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;

      a[i] = val;

    }
    return val;
  }
























  public static sglobal boolean    and (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static boolean  and (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;

      a[i] = val;

    }
    return val;
  }











   





















  public static sglobal int    gen (

				IntOp  Oper,

				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static int  gen (

				IntOp  Oper,

				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;

      a[i] = val;

    }
    return val;
  }























  public static sglobal long    gen (

				LongOp  Oper,

				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static long  gen (

				LongOp  Oper,

				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;

      a[i] = val;

    }
    return val;
  }























  public static sglobal double    gen (

				DoubleOp  Oper,

				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static double  gen (

				DoubleOp  Oper,

				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;

      a[i] = val;

    }
    return val;
  }




























  public static sglobal Object    gen (

				ObjectOp  Oper,

				Object  val) {
    Object  [1d] local a;
    Object  [1d] b;

    if (myproc == 0)
      a = new Object  [0 : procs - 1];
    b = broadcast (Object  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;


    Ti.barrier();
    return b[myproc];



  }

  public static Object  gen (

				ObjectOp  Oper,

				Object  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    Object  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;

      a[i] = val;

    }
    return val;
  }









}

