#include <AST.h>
#include <SolverInferContext.h>
#include <decls.h>

#include "solver.h"


void BroadcastNode::inferLocal( const LocalContext &context )
{
  if (type()->isInferable())
    context.solver.mustBeGlobal( *type() );
  
  infer( context );
}
