#ifndef _AMLAPI_NODE_H_
#define _AMLAPI_NODE_H_

#include <pthread.h>
#include <lapi.h>
#include "amlapi_endpoint.h"

/* Per node variables */

int nextEndpointId; /* per-node number to identify all the endpoints. Monotonically increasing. Equal to the number of endpoints ever created in this node. */
ep_t * endpointsInNode; /* a dynamically grown array that keeps track of all endpoints in this node */
int endpointsInNode_size; 
#define AMLAPI_ENDPOINTSINNODE_INC 10

pthread_mutex_t nextEndpointId_lock; /* protects the nextEndpointId and endpointsInNode */

int AMLAPI_MYNODE;
int AMLAPI_NUMNODES;
lapi_handle_t * lapi_hndl;
lapi_info_t * lapi_info;

#endif /* _AMLAPI_NODE_H_ */
