#ifndef _INCLUDE_FILE_64_H_
#define _INCLUDE_FILE_64_H_

/* these get us 64-bit file declarations under several Unixen */
#define _LARGEFILE64_SOURCE 1
#define _LARGEFILE_SOURCE 1

#include "config.h"
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "linkage.h"

#ifndef HAVE_OPEN64
# define open64 open
#endif /* !HAVE_OPEN64 */

#ifndef HAVE_LSEEK64
# ifdef HAVE_LLSEEK
#  define lseek64 llseek
# else /* !HAVE_LLSEEK */
#  define lseek64 lseek
# endif /* !HAVE_LLSEEK */
#endif /* !HAVE_LSEEK64 */

#ifndef HAVE_STAT64
# define stat64 stat
#endif /* !HAVE_STAT64 */

#ifndef HAVE_FSTAT64
# define fstat64 fstat
#endif

#ifndef O_LARGEFILE
# define O_LARGEFILE 0
#endif /* !O_LARGEFILE */


#endif /* _INCLUDE_FILE_64_H_ */
