#ifndef _INCLUDE_INSTANCE_HEADER_
#define _INCLUDE_INSTANCE_HEADER_

#include "gp-type.h"
#include "linkage.h"
#include "backend.h"

EXTERN_C_BEGIN


struct class_header;

typedef struct instance_header
{
    struct class_header * class_info;
    void (* const *interface_methods)();
#ifdef HAVE_MONITORS
  tic_monitor_t monitor;
#endif /* HAVE_MONITORS */
} instance_header;

typedef GP_type( instance_header )  GP_instance;


EXTERN_C_END

#endif
