#include <stdlib.h>
#include "fp-utils.h"
#include "gc.h"
#include "java_array.h"
#include "linkage.h"
#include "native-str-utils.h"

#include "T6String4lang4java.h"
#include "layout!PT6String4lang4java.h"

#define tossNumberFormatException m26throwNumberFormatExceptionPT6String4lang4javamT11NativeUtils4lang2ti


jdouble stringToDouble( GP_JString str )
{
  const jint length = m6lengthmT6String4lang4java( str );
  if (!length)
    tossNumberFormatException( str );
  else
    {
      const char * const begin = globalJstringToCstring( str );
      char *end;
      const jdouble result = strtod( begin, &end );

      if (end - begin == length)
	return result;
      else
	tossNumberFormatException( str );
    }

  abort(); /* should never reach here */
}


PT6String4lang4java doubleToString( jdouble value )
{
    PT6String4lang4java result;
    
    char buffer[ 32 ];
    g_fmt( buffer, value );
    
    globalize( result, java_string_build_8( buffer ) );
    return result;
}
