#ifndef _INCLUDE_RUNTIME_OPTIONS_INL_H_
#define _INCLUDE_RUNTIME_OPTIONS_INL_H_

/* user-requested defaults */
#include "config.h"

/* capabilities known to be absent from specific compilers */

/* Sun WorkShop Pro */
#ifdef __SUNPRO_C
# define FORCE_NO_RUNTIME_INLINE
#endif

#ifdef _AIX
# define FORCE_NO_RUNTIME_INLINE
#endif

/* Inline modifier */
#if defined(USE_RUNTIME_INLINE) && !defined(FORCE_NO_RUNTIME_INLINE)
#ifdef _AIX
#  define INLINE_MODIFIER __inline
#else
#  define INLINE_MODIFIER inline
#endif
#else /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */
#  define INLINE_MODIFIER
#endif /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */

#endif /* _INCLUDE_RUNTIME_OPTIONS_INL_H_ */
