#ifndef _include_static_global_h_
#define _include_static_global_h_



#if defined(MEMORY_SHARED) 
#define MAX_SMP_PROCS 1024
#define STATIC_DEF(fld)	        fld[MAX_SMP_PROCS]
#define STATIC_REF(structname, fld)  (structname[MYPROC].fld)

#define FILE_STATIC_STATIC_DEF(fld, type)	static type fld[MAX_SMP_PROCS]
#define FILE_STATIC_STATIC_REF(fld)             (fld[MYPROC])

#else /* UNIPROC */
#define STATIC_DEF(fld)         fld
#define STATIC_REF(structname, fld)  (structname.fld)

#define FILE_STATIC_STATIC_DEF(fld, type)        static type fld
#define FILE_STATIC_STATIC_REF(fld)              (fld)
#endif


#endif /* !_include_static_global_h_ */
