#ifndef _INCLUDE_ST_FIELD_H_
#define _INCLUDE_ST_FIELD_H_


class TreeNode;
class Decl;
class TypeNode;
class TreeListNode;


class TreeNode::FieldContext // The static analysis FieldContext for resolveField
{
public:
  FieldContext();
  Decl *currentPackage;
  TypeNode *currentClass;
  TreeListNode *methodArgs;
  bool inStatic; // true while in static code
  Modifiers thisModifiers;
};


inline TreeNode::FieldContext::FieldContext()
  : currentPackage(NULL),
    currentClass(NULL),
    methodArgs(NULL),
    inStatic(false),
    thisModifiers(None)
{
}


#endif
