package ti.internal;

final public immutable class tiArray {
  final public static int arity = 0;

  native public static int single arity();

  native public tiRectDomain single domain();
  native public local tiRectDomain single domain();
  native public local nonshared tiRectDomain single domain();
  native public local polyshared tiRectDomain single domain();

  native public tiArray single translate(tiPoint single p);
  native public local tiArray local single translate(tiPoint single p);
  native public local nonshared tiArray local nonshared single translate(tiPoint single p);
  native public local polyshared tiArray local polyshared single translate(tiPoint single p);

  native public tiArray single restrict(tiRectDomain single d);
  native public local tiArray local single restrict(tiRectDomain single d);
  native public local nonshared tiArray nonshared local single restrict(tiRectDomain single d);
  native public local polyshared tiArray polyshared local single restrict(tiRectDomain single d);

  native public tiArray single inject(tiPoint single p);
  native public local tiArray local single inject(tiPoint single p);
  native public local nonshared tiArray local nonshared single inject(tiPoint single p);
  native public local polyshared tiArray local polyshared single inject(tiPoint single p);

  native public tiArray single project(tiPoint single p);
  native public local tiArray local single project(tiPoint single p);
  native public local nonshared tiArray local nonshared single project(tiPoint single p);
  native public local polyshared tiArray local polyshared single project(tiPoint single p);

  native public tiArray single permute(tiPoint single p);
  native public local tiArray local single permute(tiPoint single p);
  native public local nonshared tiArray local nonshared single permute(tiPoint single p);
  native public local polyshared tiArray local polyshared single permute(tiPoint single p);

  native public tiArrayM1 single slice(int single k, int single j);
  native public local tiArrayM1 local single slice(int single k, int single j);
  native public local nonshared tiArrayM1 local nonshared single slice(int single k, int single j);
  native public local polyshared tiArrayM1 local polyshared single slice(int single k, int single j);

  native public void set(tiTemplateArgument value);
  native public local void set(tiTemplateArgument value);
  native public local nonshared void set(tiTemplateArgument value);
  native public local polyshared void set(tiTemplateArgument value);

  native public boolean isLocal();
  native public local boolean isLocal();
  native public local nonshared boolean isLocal();
  native public local polyshared boolean isLocal();

  native public boolean isContiguous();
  native public local boolean isContiguous();
  native public local nonshared boolean isContiguous();
  native public local polyshared boolean isContiguous();

  native public int creator();
  native public local int creator();
  native public local nonshared int creator();
  native public local polyshared int creator();

  native public void copy(tiArray x);
  native public void copy(tiArray local x);
  native public void copy(tiArray local nonshared x);
  native public void copy(tiArray local polyshared x);
  native public local void copy(tiArray x);
  native public local void copy(tiArray local x);
  native public local void copy(tiArray local nonshared x);
  native public local void copy(tiArray local polyshared x);
  native public local nonshared void copy(tiArray x);
  native public local nonshared void copy(tiArray local x);
  native public local nonshared void copy(tiArray local nonshared x);
  native public local nonshared void copy(tiArray local polyshared x);
  native public local polyshared void copy(tiArray x);
  native public local polyshared void copy(tiArray local x);
  native public local polyshared void copy(tiArray local nonshared x);
  native public local polyshared void copy(tiArray local polyshared x);
  // native public void copy(tiArray x, tiDomain d);

  native public single void exchange(tiTemplateArgument myValue);
  native public single local void exchange(tiTemplateArgument myValue);
  native public single local nonshared void exchange(tiTemplateArgument myValue);
  native public single local polyshared void exchange(tiTemplateArgument myValue);

  // noOverlap "pseudo-method"
  native public void noOverlap(tiArray B);
  native public local void noOverlap(tiArray B);
  native public local nonshared void noOverlap(tiArray B);
  native public local polyshared void noOverlap(tiArray B);

  // bulk I/O methods 
  native public void readFrom(java.io.RandomAccessFile RAF) throws java.io.IOException;
  native public void readFrom(java.io.DataInputStream DIS) throws java.io.IOException;
  native public void writeTo(java.io.RandomAccessFile RAF) throws java.io.IOException;
  native public void writeTo(java.io.DataOutputStream DOS) throws java.io.IOException;

  private polyshared tiArray() { }
}

